Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 1209974 (usbguard-applet-qt) - Review Request: usbguard-applet-qt - USBGuard Qt applet
Summary: Review Request: usbguard-applet-qt - USBGuard Qt applet
Keywords:
Status: CLOSED WONTFIX
Alias: usbguard-applet-qt
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Nobody's working on this, feel free to take it
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: 1209971
Blocks: qt-reviews
TreeView+ depends on / blocked
 
Reported: 2015-04-08 14:56 UTC by Daniel Kopeček
Modified: 2016-04-04 10:27 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2016-04-04 10:27:10 UTC


Attachments (Terms of Use)

Description Daniel Kopeček 2015-04-08 14:56:32 UTC
Spec URL: https://fedorapeople.org/~dkopecek/usbguard/usbguard-applet-qt.spec
SRPM URL: https://fedorapeople.org/~dkopecek/usbguard/usbguard-applet-qt-0.2-1.fc20.src.rpm
Description: USBGuard Qt applet for interaction with the USBGuard daemon.
Fedora Account System Username: mildew

Comment 1 Daniel Kopeček 2015-04-08 14:57:41 UTC
The usbguard-devel package is needed to build this one. The review bug for usbguard is here https://bugzilla.redhat.com/show_bug.cgi?id=1209971.

Comment 2 Antti Järvinen 2015-04-08 20:20:31 UTC
Hello Daniel,

I'm not in position to sponsor your package but I made a review about it. Hopefully it will be useful for someone considering sponsorship. Also, I reviewed only this Qt-GUI part, not the devel package from ticket 1209971 as I feel as not being USB-guru but this simple Qt app I do understand. 

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed

Notes:
- While there is LICENSE file in the tarball, there is no indication
  in source files that LICENSE applies to each of those files.
  Don't know if this is requirement but it would be nice at least.
  https://www.gnu.org/licenses/gpl-howto.html has copy-paste examples.
- LICENSE-file mentioned in previous note is not included in resulting
  binary rpm. Adding a line
  %license LICENSE
  into section %files should do the trick.
- CXXFLAGS/LDFLAGS may be in conflict, depending on build configuration
- % install section begins with
  rm -rf $RPM_BUILD_ROOT
- Invalid use of buildroot
- I'd love to see documentation of some kind. While the application itself
  is very simple, a manpage would not hurt.
- Obviously the icon is also covered by LICENSE?
- Wishlist item: in sources usage of tr("..") macro for strings would make
  it much easier for me to spawn linguist-qt4 and post a finnish language
  translation to author.
+ plus side: programs seems to do what is promised. .. or making claims
  about "security" is always a bit dangerous, but it seems to do what
  the website claims as functionality.

===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated". 5 files have unknown license. Detailed output of
     licensecheck in /tmp/review-1209974/1209974-usbguard-applet-
     qt/licensecheck.txt
[ ]: %build honors applicable compiler flags or justifies otherwise.
     I'm not sure. The hardening-flags LDFLAGS="-pie -Wl,-z,relro -Wl,-z,now"
     are spelled out in spec ; and only for LDFLAGS: For those hardening
     flags to make sense, some CXXFLAGS/CFLAGS might be in order, like
     --stack-proctector-something so it seems to me that one part
     of hardening flags is hard-coded here and the other part (CFLAGS)
     usually, depending on configuration, comes in via RPM_OPT_FLAGS
     but you can't know what RPM_OPT_FLAGS will be.
     So I'd advice on depending on LDFLAGS supplied by rpmbuild?
     About the -fPIE/fpie in sparc I don't know, if really necessary
     then that should remain. 
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Each %files section contains %defattr if rpm < 4.4
     Note: %defattr present but not needed
[!]: Package contains desktop file if it is a GUI application.
     It has GUI - should count as GUI app?
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
     Note: there is no documentation
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[!]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     % install section begins with
     rm -rf $RPM_BUILD_ROOT
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[!]: Buildroot is not present
     Note: Invalid buildroot found:
     %{_tmppath}/%{name}%{version}-%{release}-root-%(%{__id_u} -n)
     See: http://fedoraproject.org/wiki/Packaging/Guidelines#BuildRoot_tag
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: %clean present but not required
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
     Starts, yes. 
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[ ]: Package should compile and build into binary rpms on all supported
     architectures.
     Note: Tried only amd64. In RPM there is discussion about sparc builds
     so obviously packager has tried other hw platforms too.
[-]: %check is present and all tests pass.
    Note: there seems to be no test-suite in sources
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: usbguard-applet-qt-0.2-1.fc21.x86_64.rpm
          usbguard-applet-qt-0.2-1.fc21.src.rpm
usbguard-applet-qt.x86_64: W: no-documentation
usbguard-applet-qt.x86_64: W: no-manual-page-for-binary usbguard-applet-qt
2 packages and 0 specfiles checked; 0 errors, 2 warnings.




Rpmlint (installed packages)
----------------------------
Cannot parse rpmlint output:


Requires
--------
usbguard-applet-qt (rpmlib, GLIBC filtered):
    libQtCore.so.4()(64bit)
    libQtGui.so.4()(64bit)
    libc.so.6()(64bit)
    libdl.so.2()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libm.so.6()(64bit)
    libpthread.so.0()(64bit)
    libqb.so.0()(64bit)
    librt.so.1()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    libusbguard.so.0()(64bit)
    rtld(GNU_HASH)
    usbguard



Provides
--------
usbguard-applet-qt:
    usbguard-applet-qt
    usbguard-applet-qt(x86-64)



Source checksums
----------------
https://dkopecek.github.io/usbguard/dist/usbguard-applet-qt-0.2.tar.gz :
  CHECKSUM(SHA256) this package     : e8c8cc551b3375f4dffbe2679fa8d13b24abb1e228ec7290e3ce0957020af12b
  CHECKSUM(SHA256) upstream package : e8c8cc551b3375f4dffbe2679fa8d13b24abb1e228ec7290e3ce0957020af12b


Generated by fedora-review 0.5.2 (63c24cb) last change: 2014-07-14
Command line :/usr/bin/fedora-review --mock-config fedora-review -o --no-cleanup-after --no-clean -b 1209974
Buildroot used: fedora-21-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG

Comment 3 Daniel Kopeček 2015-04-09 07:38:54 UTC
Hello Antti,

(In reply to Antti Järvinen from comment #2)
> Hello Daniel,
> 
> I'm not in position to sponsor your package but I made a review about it.
> Hopefully it will be useful for someone considering sponsorship. Also, I
> reviewed only this Qt-GUI part, not the devel package from ticket 1209971 as
> I feel as not being USB-guru but this simple Qt app I do understand. 

thank you for the review! I'll fix the issues you found.

Comment 4 Daniel Kopeček 2015-04-09 15:38:33 UTC
Fixed SRPM. Spec URL is the same.

SRPM URL: https://fedorapeople.org/~dkopecek/usbguard/usbguard-applet-qt-0.3-1.fc20.src.rpm

Comment 5 Daniel Kopeček 2015-04-09 15:43:58 UTC
(In reply to Antti Järvinen from comment #2)
> Hello Daniel,
> 
> I'm not in position to sponsor your package but I made a review about it.
> Hopefully it will be useful for someone considering sponsorship. Also, I
> reviewed only this Qt-GUI part, not the devel package from ticket 1209971 as
> I feel as not being USB-guru but this simple Qt app I do understand. 
> 
> Package Review
> ==============
> 
> Legend:
> [x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
> [ ] = Manual review needed
> 
> Notes:
> - While there is LICENSE file in the tarball, there is no indication
>   in source files that LICENSE applies to each of those files.
>   Don't know if this is requirement but it would be nice at least.
>   https://www.gnu.org/licenses/gpl-howto.html has copy-paste examples.

Fixed.

> - LICENSE-file mentioned in previous note is not included in resulting
>   binary rpm. Adding a line
>   %license LICENSE

Added.

>   into section %files should do the trick.
> - CXXFLAGS/LDFLAGS may be in conflict, depending on build configuration

Removed the harden build flags. I'll reconsider hardened build enabled using the _hardened_build rpm variable.

> - % install section begins with
>   rm -rf $RPM_BUILD_ROOT
> - Invalid use of buildroot

Fixed.

> - I'd love to see documentation of some kind. While the application itself
>   is very simple, a manpage would not hurt.

Added man page.

> - Obviously the icon is also covered by LICENSE?

Changed license in the svg files.

> - Wishlist item: in sources usage of tr("..") macro for strings would make
>   it much easier for me to spawn linguist-qt4 and post a finnish language
>   translation to author.

Should be fixed, I've added tr() where appropriate.

> Generic:
> [!]: If (and only if) the source package includes the text of the license(s)
>      in its own file, then that file, containing the text of the license(s)
>      for the package is included in %doc.
> [!]: Package contains desktop file if it is a GUI application.
>      It has GUI - should count as GUI app?
> [!]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
>      beginning of %install.
>      % install section begins with
>      rm -rf $RPM_BUILD_ROOT
> ===== SHOULD items =====
> 
> Generic:
> [!]: Buildroot is not present
>      Note: Invalid buildroot found:
>      %{_tmppath}/%{name}%{version}-%{release}-root-%(%{__id_u} -n)
>      See: http://fedoraproject.org/wiki/Packaging/Guidelines#BuildRoot_tag

Fixed.

Comment 6 Raphael Groner 2015-11-27 20:32:46 UTC
As a first step, I've some general hints to your spec file:
- Is there support for Qt5? Please notice that upstream announced to stop 
  further development for Qt4.

- Remove the Group: tag, it's obsolete.

- You can shorten the Source URL:
Source0:        %{url}/dist/%{name}-%{version}.tar.gz

- You can use %make_build, instead of: make %{?_smp_mflags}

- Maybe use also %make_install, instead of: make install DESTDIR=%{buildroot}

- %defattr is not needed, please remove that line from %files.

- Use %{name} where applicable for the file names:
%{_bindir}/%{name}
%{_mandir}/man1/%{name}.1*
%{_datadir}/applications/%{name}.desktop

- You can skip the compression of manpage in cmake. The compression method may
  change and rpmbuild does that automatically, so it is important to reference
  the pages in the %files section with a pattern that takes this into account.
https://fedoraproject.org/wiki/Packaging:Guidelines#Manpages

- Use desktop-file-validate for the installed desktop file. 
https://fedoraproject.org/wiki/Packaging:Guidelines#desktop-file-install_usage

- Install the application icon in hicolor icons folder and include the 
  scriptlets.
https://fedoraproject.org/wiki/Packaging:ScriptletSnippets#Icon_Cache

Comment 7 Raphael Groner 2015-11-27 20:46:15 UTC
FTBFS in mock:
[ 69%] Building CXX object CMakeFiles/usbguard-applet-qt.dir/src/devicedialog.cpp.o
/usr/lib64/ccache/c++   -DQT_CORE_LIB -DQT_GUI_LIB -DQT_NO_DEBUG -I/usr/include/usbguard -I/builddir/build/BUILD/usbguard-applet-qt-0.3 -isystem /usr/include/QtGui -isystem /usr/include/QtCore  -O2 -g -pipe -Wall -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector-strong --param=ssp-buffer-size=4 -grecord-gcc-switches -specs=/usr/lib/rpm/redhat/redhat-hardened-cc1 -m64 -mtune=generic  -std=c++11 -Wall   -o CMakeFiles/usbguard-applet-qt.dir/src/main.cpp.o -c /builddir/build/BUILD/usbguard-applet-qt-0.3/src/main.cpp
/usr/lib64/ccache/c++   -DQT_CORE_LIB -DQT_GUI_LIB -DQT_NO_DEBUG -I/usr/include/usbguard -I/builddir/build/BUILD/usbguard-applet-qt-0.3 -isystem /usr/include/QtGui -isystem /usr/include/QtCore  -O2 -g -pipe -Wall -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector-strong --param=ssp-buffer-size=4 -grecord-gcc-switches -specs=/usr/lib/rpm/redhat/redhat-hardened-cc1 -m64 -mtune=generic  -std=c++11 -Wall   -o CMakeFiles/usbguard-applet-qt.dir/src/mainwindow.cpp.o -c /builddir/build/BUILD/usbguard-applet-qt-0.3/src/mainwindow.cpp
/usr/lib64/ccache/c++   -DQT_CORE_LIB -DQT_GUI_LIB -DQT_NO_DEBUG -I/usr/include/usbguard -I/builddir/build/BUILD/usbguard-applet-qt-0.3 -isystem /usr/include/QtGui -isystem /usr/include/QtCore  -O2 -g -pipe -Wall -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector-strong --param=ssp-buffer-size=4 -grecord-gcc-switches -specs=/usr/lib/rpm/redhat/redhat-hardened-cc1 -m64 -mtune=generic  -std=c++11 -Wall   -o CMakeFiles/usbguard-applet-qt.dir/src/devicedialog.cpp.o -c /builddir/build/BUILD/usbguard-applet-qt-0.3/src/devicedialog.cpp
In file included from /usr/include/usbguard/IPCClient.hpp:21:0,
                 from /builddir/build/BUILD/usbguard-applet-qt-0.3/src/mainwindow.h:25,
                 from /builddir/build/BUILD/usbguard-applet-qt-0.3/src/main.cpp:19:
/usr/include/usbguard/IPC.hpp:25:20: fatal error: sodium.h: No such file or directory
compilation terminated.
In file included from /usr/include/usbguard/IPCClient.hpp:21:0,
                 from /builddir/build/BUILD/usbguard-applet-qt-0.3/src/mainwindow.h:25,
                 from /builddir/build/BUILD/usbguard-applet-qt-0.3/src/mainwindow.cpp:19:
/usr/include/usbguard/IPC.hpp:25:20: fatal error: sodium.h: No such file or directory
compilation terminated.
CMakeFiles/usbguard-applet-qt.dir/build.make:90: recipe for target 'CMakeFiles/usbguard-applet-qt.dir/src/main.cpp.o' failed
CMakeFiles/usbguard-applet-qt.dir/build.make:114: recipe for target 'CMakeFiles/usbguard-applet-qt.dir/src/mainwindow.cpp.o' failed

Comment 8 Daniel Kopeček 2015-11-30 08:31:45 UTC
(In reply to Raphael Groner from comment #6)

Thanks for reviewing this! It's been a while since I created the review request. I'll try to fix the issues you found during this week, when time allows.

Comment 9 Raphael Groner 2016-03-28 19:22:29 UTC
Ping? Are you still interested to find a reviewer?

Comment 10 Daniel Kopeček 2016-04-04 10:27:10 UTC
(In reply to Raphael Groner from comment #9)
> Ping? Are you still interested to find a reviewer?

No, thanks. I'm going to address the issues found during the this review, but since I obsoleted the standalone applet package in upstream, I no longer need this separate package review to be completed.


Note You need to log in before you can comment on or make changes to this bug.